<?
/*
**************************************************************************

           TPLN v.1.3  by HAYOUN Laurent

           website: http://tpln.sourceforge.net
           email: php_work@hotmail.com

***************************************************************************
*/

//Initialisation de l'include_path
$old_path = ini_get('include_path');
$os = ((stristr(getenv('SERVER_SOFTWARE'), 'win') || stristr(getenv('SERVER_SOFTWARE'), 'microsoft'))? ';' : ':');
$path = $os.ini_get('include_path');
ini_set('include_path', $path);

//Inclusion du fichier de configuration et de Db
require_once('TPLN_Cfg.php');
require_once('TPLN_Debug.php');
require_once('TPLN_Error.php');
require_once('TPLN_DB_Xtra.php');
require_once('TPLN_DB.php');


// on remet l'include path au fichier appellant
ini_set('include_path', $old_path);


class TPLN extends TPLN_DB
{
 var $php_file_extension = "php|phtml|php4|php3"; // extensions de fichiers php

 var $def_tpl = array(); // liste des template dfini avec un nom

 var $f = -1; // indice de fichier

 var $f_name = array(); // nom de fichier appell
 var $f_buffer = array(); // structure du fichier
 var $f_items = array(); // capture de tous les items du fichier
 var $f_php_items = array(); // capture les items avec $

 var $f_blocs = array(); // capture de tous les noms de blocs
 var $f_bloc_items = array(); // capture tous les items d'un bloc

 var $f_cmd = array(); // retiens les instructions de includes
 var $f_cmd_eval = array(); // doit ton evaluer les fichiers inclus ?

 var $add_cached_file = array(); // gestion du cache
 var $is_cached = array(); // gestion du cache
 var $time_started = array();
 var $cache_expire = array();

 var $bloc = array(); // capture les blocs (structure,items,parsed)
 var $bloc_loop = array(); // stocke les bloc loop
 var $last_bloc_path = array(); // retiens le chemin du dernier bloc
 var $end_bloc_tmp = array(); // retiens les bloc avant leur sortie

// chrono
 var $execution_time = array();
 var $chrono_started = array();
 var $chrono_type = array(); // on veut le chrono de qui ?



/********************************************
              General
*********************************************/

// ouvre un fichier et le place en mmoire
// gestion des erreurs 0 fichier non trouv
 function Open($file,$cached="",$cached_time="")
 {

  $this->f++;  // incremante


  $this->f_name[$this->f] = $file;

  $time = explode(' ',microtime());
  $this->time_started[$this->f] = time(); // dans pour le cache  la seconde
  $this->chrono_started[$this->f] = $time[1] + $time[0];

  // on dfinit le chrono
  if(!defined(TPLN_CHRONO_STARTED))
   {
    define("TPLN_CHRONO_STARTED",$this->chrono_started[0]);
   }

   // on regarde si le fichier est en cache
   if(!empty($cached))
    {
      //$this->_AddTraceMsg("cache mode detected");

      $this->_CacheDirExists();

      if(empty($cached_time)){$cached_time = TPLN_CACHE_TIME;}
      $this->cache_expire[$this->f] = $this->time_started[$this->f]+$cached_time; // cache d'expiration

      // on regarde le fichier est encore en cache
      // fichier existe && sa date de creation est <= au temps de cache
      if(file_exists(TPLN_CACHE_DIR.$this->f_name[$this->f]) && $this->_InCachePeriod())
       {
        //$this->_AddTraceMsg("get cached file");
        $this->_GetCachedFile();
        return true;
       }
      else
       {
        //$this->_AddTraceMsg("the file will be cached next time");
        $this->add_cached_file[$this->f] = 1;

       }
    }

     $this->f_buffer[$this->f] = $this->GetFile($this->f_name[$this->f]);
     $this->f_items[$this->f] = $this->_CaptureItems();
     $this->f_blocs[$this->f] = $this->_CaptureAllBlocs();
     $this->_EndBlocVerify();
     $this->_CaptureItemsInEachBloc();
     $this->_CaptureIncludeCmd(); // capture des commandes include

     if(TPLN_PARSE_GLOBALS == 1)
      {
       $this->ParseGlobals(); // remplace les variables avec $
      }

   // debugger
   $this->_StructOpen();

   if($this->add_cached_file[$this->f] == 1){ return false;}
 }

// defini plusieurs template par leur nom
function DefineTemplate($arr)
{
  if(!is_array($arr))
   {
     //$this->_AddTraceMsg();
     $this->_Error(12);
     return;
   }

   foreach($arr as $key=>$val)
     {
       $this->Open($val);
       $this->def_tpl[count($this->f_name)-1] = $key;
     }
}


// fonction pour le template
function SetTemplate($key)
{
  //$this->_AddTraceMsg("get template id $id");
  if(is_string($key))
  {
    // on prend l'id
     if(!in_array($key,$this->def_tpl,TRUE))
     {
      $this->_Error(11,$key);
      return;
     }

    $key = array_search($key,$this->def_tpl,TRUE);

  }

  if(is_int($key))
  {
    if($key < 0 || $key >= count($this->f_name))
      {
       //$this->_AddTraceMsg();
       $this->_Error(10,$key);
      }
   }

  $this->f = $key;
}

function ParseGlobals()
{
  $this->f_php_items[$this->f] = $this->_CaptureItems("",PHP);

  if(count($this->f_php_items[$this->f]) == 0)
  {
   return;
  }

  // on rajoute le signe $ au tableau
  foreach($this->f_php_items[$this->f] as $item)
  {
    $n_php_items[] = '$'.$item;
  }


  // on efface les items trouv des items gnraux
  $n_items = array_diff($this->f_items[$this->f],$n_php_items);
  $this->f_items[$this->f] = $n_items;

  foreach($this->f_php_items[$this->f] as $item)
   {
     // on regarde si la variable est _GET ou _POST ou _SESSION
     if(substr($item,0,1) != '_') // pas de signe $_ au dbut
      {
       $replace = $GLOBALS[$item];
      }
      else
      {
       $replace = '$'.$item;
       eval("\$replace = $replace;");
      }

     $item = '$'.$item;
     $item = str_replace('$','\$',$item);
     $item = str_replace('[','\[',$item);
     $item = str_replace(']','\]',$item);
     $this->f_buffer[$this->f] = $this->_ReplaceItem($item, $replace, $this->f_buffer[$this->f]);
   }
}


// fonction de parsing
 function Parse($item,$replace,$functions="")
 {
   $tmp_replace = htmlspecialchars($replace);
   //empty($functions) ? $this->_AddTraceMsg("parse item $item replace $tmp_replace") : //$this->_AddTraceMsg("parse item $item replace $tmp_replace functions $functions");

  // fonction de formatage des donnes
  $replace = $this->_ApplySpecialFunction($replace,$functions);

  if($this->_IsBloc($item))  // si c'est un bloc
   {
      //$this->_AddTraceMsg("Bloc detected");

      $b = $this->_Bloc($item);

      $item = $b["item"];
      $path =  $b["path"];
      $all_bloc = $b["all_bloc"];
      $bloc_name =  $b["bloc_name"];
   }

  // verification dans un bloc ?
  if(!empty($bloc_name))
   {
     $this->_ItemVerify($item,$bloc_name);
   }
  else
  {
    $this->_ItemVerify($item);
  }

  if(count($b) > 0) // parsing dans un bloc
    {
      $ref = &$this->bloc[$this->f];

     // prend le chemin et la structure
     // des peres du bloc
     for($i=0;$i<count($all_bloc)-1;$i++)
      {
       $ref = &$ref[$all_bloc[$i]]["children"];
      }

     // remplacement dans un bloc normal
     if(!@in_array($path,$this->bloc_loop[$this->f]))
      {
       //$this->_AddTraceMsg("parse in a normal bloc");
       $structure = $ref["$bloc_name"]["parsed"];
       $tmp_replace = $this->_ReplaceItem($item,$replace,$structure);
       $ref["$bloc_name"]["parsed"] = $tmp_replace;
      }
     else
      {
       // bloc loop
       //$this->_AddTraceMsg("parse in a loop bloc");
       $structure = $this->bloc_loop[$this->f]["$path"]["parsed"];
       $tmp_replace = $this->_ReplaceItem($item,$replace,$structure);
       $this->bloc_loop[$this->f]["$path"]["parsed"] = $tmp_replace;
      }

    }
  else
    {
     //$this->_AddTraceMsg("parse in file");
     $this->f_buffer[$this->f] = $this->_ReplaceItem($item,$replace,$this->f_buffer[$this->f]);
    }
 }

// mthode pour acclrer le parsing cot user
function FastParse($path,$functions="")
{
 //$this->_AddTraceMsg("add parse method");

  // Est ce un bloc alors on remplace
  if($this->_IsBloc($path))
   {
      $item =  $this->_GetItem($path);// on prens le dernier item
   }
  else
   {
      $item = $path;
   }

  $this->Parse($path, $GLOBALS[$item], $functions);
}


// DB mthode pour le parsing
function ParseDBRow($bloc)
{
  while($row = $this->DBFetchAssoc())
  {
    $keys = @array_keys($row);// prise du mon des clefs
    // echo "{$row['User']} {$row['Password']}<br>";
    foreach($keys as $key)
     {
       if($this->ItemExists($key,$bloc))
        {
         $this->Parse("$bloc.$key",$row["$key"]);
        }
     }
     $this->Loop("$bloc");
  }
}

// charge un array dans un bloc
function LoadArrayInBloc($bloc_name,$arr)
{
  if(count($arr) == 0){return;}

  foreach($arr as $current_arr)
   {
      $keys = @array_keys($current_arr);// prise des clefs

      foreach($keys as $key)
       {
         $this->Parse("$bloc_name.$key", $current_arr[$key]);
       }

       $this->Loop($bloc_name);
   }

}

// loop pour savoir si le bloc doit tre en loop ou pas ?
 function Loop($path="")
 {
  if(empty($path) || ($path == "this"))
    {$path = $this->last_bloc_path[$this->f];}

 $all_bloc = explode(".",$path);
 $last_bloc_name = $all_bloc[count($all_bloc)-1];

 // on atteint le bloc
 $ref = &$this->bloc[$this->f];

 // prend le chemin et la structure des pres du bloc
 for($i=0;$i<count($all_bloc)-1;$i++)
  {$ref = &$ref[$all_bloc[$i]]["children"];}

 // initialisation
 if(!@in_array($path,$this->bloc_loop[$this->f]))
   {
    $this->bloc_loop[$this->f][] = $path;
   }
  else
   {
    $ref["$last_bloc_name"]["parsed"] .= $this->bloc_loop[$this->f]["$path"]["parsed"]; // assignation de la structure
   }

   $this->bloc_loop[$this->f]["$path"]["parsed"] = $ref["$last_bloc_name"]["structure"];     // initialisation de la structure

 }

// effacement d'un item
 function EraseItem($item)
 {
   $this->Parse($item,"");
 }


// effacement d'un bloc
 function EraseBloc($path)
 {
  // vrification de l'existance des bloc
  //  et assignation en cas de ngativit
  $all_bloc = explode(".",$path);
  $bloc_name = $all_bloc[count($all_bloc)-1];

    for($i=0;$i<count($all_bloc);$i++)
    {
      $i == 0 ? $tmp_path = $all_bloc[$i] : $tmp_path .= ".".$all_bloc[$i];
      $bloc = $this->_Bloc($tmp_path,SHORT);
    }


   $all_bloc = $bloc["all_bloc"];
   $bloc_name =  $bloc["bloc_name"];

   // big father
   if(count($all_bloc) == 1)
    {
     $this->f_buffer[$this->f] = $this->_ReplaceBloc($bloc_name,"",$this->f_buffer[$this->f]);
     unset($this->bloc[$this->f]["$bloc_name"]); // effacement dans les bloc definis
    }
   else
    {
       $ref = &$this->bloc[$this->f];

         for($i=0;$i<count($all_bloc)-1;$i++)
          {
           $ref = &$ref[$all_bloc[$i]]["children"];
          }

        $ref["$bloc_name"]["parsed"] = "";
    }

 }


// ouvre et retourne le fichier
function GetFile($filename,$blocname="")
{
  //$this->_AddTraceMsg("get file $filename");

  if(!$fp = @fopen($filename, "r")) // ouverture du fichier
     {
      //$this->_AddTraceMsg();
      $this->_Error(0,$filename);
     }

      $filebuffer = @fread($fp,filesize($filename));
      @fclose($fp);
      clearstatcache(); // efface la mmoire tampon

      if(!empty($blocname)) // on veut capturee un bloc
        {
         $filebuffer = $this->_CaptureBloc($blocname,$filebuffer);
        }

 return $filebuffer;
}


/*// fonction writebloc cre chez son pere
 function WriteBloc($path="")
 {
   if(empty($path) || ($path == "this"))
    {$path = $this->last_bloc_path;}

   $path = explode(".",$path);
   if(count($path) == 1)
   {return;}    // c'est un big father on sort

   // on met le contenu du fils parsed chez le pere
   $last_bloc_name = $path[count($path)-1];
   $fathers = array_slice($path,0,count($path)-1); // tous les noms sauf le dernier

   // on atteint le niveau du bloc pour l'ecriture
   $ref = &$this->bloc;

   for($i=0;$i<count($fathers);$i++)
    {
     // c'est le dernier pere
     if($i == count($fathers) -1)
      {
        $father = &$ref[$fathers[$i]];
        $father_parsed = &$ref[$fathers[$i]]["parsed"];
      }

     $ref = &$ref[$fathers[$i]]["children"];

    }

   $father["parsed"] = $this->_ReplaceBloc($last_bloc_name,$ref["$last_bloc_name"]["parsed"],$father_parsed);
   unset($ref["$last_bloc_name"]["parsed"]);// on efface le parsed du fils utile pour les loop
   //$ref["$last_bloc_name"]["parsed"] = $ref["$last_bloc_name"]["structure"];
 }
*/
 // remplacement d'un bloc entier
 function ParseBloc($path,$replace)
 {
  // vrification de l'existance des bloc
  $all_bloc = explode(".",$path);
  //  et assignation en cas de ngativit
    for($i=0; $i < count($all_bloc); $i++)
    {
      $i == 0 ? $tmp_path = $all_bloc[$i] : $tmp_path .= ".".$all_bloc[$i];
      $bloc = $this->_Bloc($tmp_path,SHORT);
    }

    $all_bloc = $bloc["all_bloc"];
    $bloc_name = $bloc["bloc_name"];

   // on remplace le bloc par son remplacant dans son pere
   $ref = &$this->bloc[$this->f];

   for($i=0;$i<count($all_bloc)-1;$i++)
     {$ref = &$ref[$all_bloc[$i]]["children"];}

    $ref["$bloc_name"]["parsed"] = $replace;

 }


// inclusion d'un fichier dans un item
function IncludeFile($item,$file)
{
  $this->Parse($item,"{#include($file)}"); // on replace par la commande include
  $this->f_cmd[$this->f][] = $file; // on ajoute  la liste des f_cmd

}


// sortie d'un bloc
function GetBlocInFile($path)
 {
   $all_bloc = explode(".",$path);
   $bloc_name =  $all_bloc[count($all_bloc)-1];

   $bloc = $this->_CaptureBloc($bloc_name,$this->f_buffer[$this->f]);
   return $bloc;
}

// sortie du fichier en mmoire
 function Write()
 {
   $this->_Out();
   echo $this->f_buffer[$this->f];
   $this->_CreateCache(TPLN_CACHE_DIR.$this->f_name[$this->f]);
 }


// sortie du fichier en mmoire
// le place dans une variable
 function Output()
 {
   $this->_Out();
   $this->_CreateCache(TPLN_CACHE_DIR.$this->f_name[$this->f]);
   return $this->f_buffer[$this->f];
 }

/*************** additionnal *****************************/
// pour les fonctions spciales
function _ApplySpecialFunction($replace="", $functions="")
{

 if(empty($functions)){return $replace;}

   //$this->_AddTraceMsg("apply special function on $replace");

   // y a t'il une fonction spciale ?
    $functions = explode("|",$functions);

    foreach($functions as $function_name)
     {
       if($function_name != "B" && $function_name != "I" && $function_name != "U" && !empty($function_name))
        {$replace = $function_name("$replace");}
     }

    // Bold, Italic, Underline
    if(in_array("B",$functions)){$replace = "<b>$replace</b>";}
    if(in_array("I",$functions)){$replace = "<i>$replace</i>";}
    if(in_array("U",$functions)){$replace = "<u>$replace</u>";}


 return $replace;
}

// avant la sotie de bloc
 function _ParsingProcess()
 {
   $this->_AllWriteBloc();  // on obtiens les blocs
   $this->_AllBlocParsingProcess();  // on les assign aux peres
 }


function _Out()
{
  if(count($this->bloc[$this->f]) > 0) // y des bloc ?
    {
     $this->_ParsingProcess();
    }

   $this->_ParseIncludeCmd();
   $this->_ParseChrono();
   $this->_ParseLogo();
   $this->_TraceMsgOut();
}

/********************************************
              Capture
*********************************************/
// fonction capture item
// et titre que ce d'un bloc
 function _CaptureItems($subject="",$type="")
 {

   if(empty($subject))
    {
        //$this->_AddTraceMsg("capture all items");
        $subject = &$this->f_buffer[$this->f]; // ds le fichier
    }
   else
    {
     //$this->_AddTraceMsg("capture items of $subject");
     $subject = $this->GetBlocInFile($subject);

     // on capture les blocs du sujet
     $blocs = $this->_CaptureAllBlocs($subject);

     // on les efface
     foreach($blocs as $bloc)
      {
       $subject = $this->_ReplaceBloc($bloc,"",$subject);
      }
    }

  $type == "PHP" ?  $motif = "/\{\\$(.*)?\}/msU" : $motif = "/\{(.*)?\}/msU" ;
  $match = preg_match_all($motif,$subject,$tab);

   // on ddoublonne le tableau
   if(count($tab[1]) > 0)
    {
     $one = array_unique($tab[1]);
    }

   return $one;
 }

// fonction qui capture un bloc sans ses motif
 function _CaptureBloc($name,$subject)
 {
  //$this->_AddTraceMsg("capture bloc $name");

  if(empty($name))
    {
     //$this->_AddTraceMsg();
     $this->_Error(5,$this->f_name[$this->f]);
     return;
    }

   $motif = "<bloc::$name>(.*)?<\\/bloc::$name>";
   $match = preg_match("/$motif/msU",$subject,$bloc);

   // error
   if(!$match)
    {
     //$this->_AddTraceMsg();
     $this->_Error(2,$this->f_name[$this->f],$name);
     return;
    }

  $bloc = trim($bloc[1])."\n";

  return $bloc;
 }

// fonction qui capture tous les blocs du sujet
 function _CaptureAllBlocs($subject="")
 {
   if(empty($subject)){$subject = &$this->f_buffer[$this->f];}

   $motif = "<bloc::(.*)?>";
   $match = preg_match_all("/$motif/U",$subject,$blocs);

   //$this->_AddTraceMsg("capture all bloc");
   return $blocs[1];
 }

// capture les items de tous les blocs du fichiers
function _CaptureItemsInEachBloc()
{
  if(count($this->f_blocs[$this->f]) == 0) {return;}

 foreach($this->f_blocs[$this->f] as $bloc)
  {
    $this->f_bloc_items[$this->f][$bloc] = $this->_CaptureItems($bloc);
  }

}

// preds les blocs du sujet
function _GetAllBlocs($subject)
{
   $motif = "<bloc::(.*)?>";
   preg_match_all("/$motif/U",$subject,$blocs);
   return $blocs[1];
}


// capture les instructions include au sein d'un template
 function _CaptureIncludeCmd()
 {
   $motif = "\{#include\((.*)?\)\}";
   $match = preg_match_all("/$motif/U",$this->f_buffer[$this->f],$tab);

   $this->f_cmd[$this->f] = $tab[1];
   //$this->_AddTraceMsg("capture include commands");
 }

/********************************************
              Verification
*********************************************/
function ItemExists($item_name,$bloc="")
{
  if(empty($bloc))
  {

    if(@in_array($item_name,$this->f_items[$this->f]))
   {
     return true;
   }
   else
    {
      return false;
    }
  }
  else
  {
    if(@in_array($item_name,$this->f_bloc_items[$this->f][$bloc]))
   {
     return true;
   }
   else
    {
      return false;
    }

  }

}

function _ItemVerify($item,$bloc="")
{

  if(empty($bloc))
  {
  //$this->_AddTraceMsg("verify item $item");
  if(!$this->ItemExists($item))
    {
     //$this->_AddTraceMsg();
     $this->_Error(1,$this->f_name[$this->f],"",$item);
     return;
    }
  }
  else
  {
  //$this->_AddTraceMsg("verify item $item in bloc $bloc");
  if(!$this->ItemExists($item,$bloc))
    {
     //$this->_AddTraceMsg();
     $this->_Error(1.1,$this->f_name[$this->f],$bloc,$item);
     return;
    }

  }

}


// existance d'un bloc
function BlocExists($bloc_name)
{
   if(@in_array($bloc_name,$this->f_blocs[$this->f]))
   {
     return true;
   }
   else
    {
      return false;
    }
}




// verifie l'existence de la fin du bloc
function _EndBlocVerify()
{
  //$this->_AddTraceMsg("verify end bloc");

  foreach($this->f_blocs[$this->f] as $bloc_name)
  {
   $motif = "/<\\/bloc::$bloc_name>/U";
   if(!preg_match($motif,$this->f_buffer[$this->f]))
    {
     //$this->_AddTraceMsg();
     $this->_Error(8,$this->f_name[$this->f],$bloc_name);
     return;
    }
  }
}

/********************************************
                    Parsing
*********************************************/
// item replace
 function _ReplaceItem($name,$replace,$subject)
 {
   //$this->_AddTraceMsg("replace item $name");

   if(empty($name))
    {
     //$this->_AddTraceMsg();
     $this->_Error(6,$this->f_name[$this->f]);
     return;
    }

   //echo "$name => $replace<hr>";

   $str = preg_replace("/\{$name\}/U",$replace,$subject);
   return $str;
 }

// fonction qui replace un bloc sans ses motifs
 function _ReplaceBloc($name,$replace,$subject)
 {
   //$this->_AddTraceMsg("replace bloc $name");
  if(empty($name))
   {
    //$this->_AddTraceMsg();
    $this->_Error(5,$this->f_name[$this->f]);
    return;
   }

   // c'est pas un tableau
   if(!is_array($name) && !is_array($replace))
    {
     $motif = "<bloc::$name>(.*)?<\\/bloc::$name>";
     $str = @preg_replace("/$motif/msU",$replace,$subject);
    }
    else
    {
     $str = @preg_replace($name,$replace,$subject);
    }
   return $str;
 }

//  fonction spciale pour les include dans le fichier
function _ParseIncludeCmd()
{
  if(count($this->f_cmd[$this->f]) == 0)
     {
       return;
     }

  //$this->_AddTraceMsg("execute include command");

     foreach($this->f_cmd[$this->f] as $filename)
      {
        $this->_IsPhpFile($filename); // on prend l'extension du fichier
        $filebuffer = $this->GetFile($filename);
        $motif = "{#include($filename)}";
        $this->f_buffer[$this->f] = str_replace($motif,$filebuffer,$this->f_buffer[$this->f]);
      }

     $this->_EvalFile(); // y a t'il du code Php ?
}

// eval Html ?
function _EvalFile()
{
  if($this->f_cmd_eval[$this->f] == 1)
   {
     $this->f_buffer[$this->f] = $this->_EvalHtml($this->f_buffer[$this->f]);
   }
}

function _EvalHtml($string)
{
  return preg_replace("/(<\?php|<\?)(.*?)\?>/sie","_EvalBuffer('\\2')",$string);
}



// est ce un fichier php ?
function _IsPhpFile($filename)
{
  if(preg_match("/\.($this->php_file_extension)$/i",$filename))
   {
      $this->f_cmd_eval[$this->f] = 1;
   }
}



/****************************************************
                        Bloc
*****************************************************/

function _IsBloc($path)
{
  if(preg_match("/[.]/",$path))
   {
    return true;
   }
  else
   {
    return false;
    }
}

// recupre l'item d'un path
function _GetItem($path)
{
  if(!preg_match("/[.]/",$path)) {return;}

  $path_arr = explode(".", $path);
  return $path_arr[count($path_arr)-1];
}

// recupere les pres
function _GetFathers($path,$type)
{
  if(!preg_match("/[.]/",$path)) {return;}

  $path_arr = explode(".", $path);
  $fathers_arr = array_slice($path_arr,0,count($path_arr)-1); // tous les noms sauf le dernier

  if($type == "ARRAY")
   {
     return $fathers_arr;
   }
   else
   {
     $fathers_path = join(".",$fathers_arr);
     return $fathers_path;
   }
}


// retourne item  parser et le chemin pour arriver au bloc
// type LONG pour un parsing normal
// SHORT pour effacement d'un bloc
 function _Bloc($total_item,$type="LONG")     // verification du bloc et retourne l'item
 {
    $all_bloc_path = explode(".",$total_item); // on scinde en tableau

  if($type == "LONG")
   {
    $item = $all_bloc_path[count($all_bloc_path)-1]; // item dernier lment du tableau
    $all_bloc_path = array_slice($all_bloc_path,0,count($all_bloc_path)-1);// suppression de l'item du tableau dernier lment
   }

   $path = join(".",$all_bloc_path);
   $fathers_path = array_slice($all_bloc_path,0,count($all_bloc_path)-1); // tous les noms sauf le dernier
   $last_bloc = $all_bloc_path[count($all_bloc_path)-1];

   $this->last_bloc_path[$this->f] = join($all_bloc_path,".");

   // si un bloc est appel ses peres sont dja dfinis
   // verification de la dfinition des peres
   for($i=0;$i<count($fathers_path);$i++)
   {
    if(!@in_array($fathers_path[$i],$this->all_bloc_def[$this->f]))
       {
        $this->_Error(4,$this->f_name[$this->f],$this->last_bloc_path[$this->f]);
       }
    }

     // definition du dernier bloc si non dfini
    if(!@in_array($last_bloc,$this->all_bloc_def[$this->f]))
    {
      // Big father ou pas
      if(count($fathers_path) == 0)
        {
         $this->_BlocDefine($last_bloc,father);
        }
      else
        {
          $bloc_construct = $this->_BlocDefine($last_bloc,children); // definition
          $this->_SaveChildrenBloc($bloc_construct,$last_bloc,$fathers_path); // encapsulation
        }
    }

  if($type == "LONG") // utile pour un parsing normal
   {
    $bloc["item"] = $item;
   }

  $bloc["path"] = $path;
  $bloc["all_bloc"] = $all_bloc_path;
  $bloc["bloc_name"] = $last_bloc;

  return $bloc;

}

 // definition d'un bloc
 function _BlocDefine($bloc_name,$type)
 {
  // analyse du bloc pere s la source
  // les fils sont chez le pere ;-)
  $struct_blc = $this->_CaptureBloc($bloc_name,$this->f_buffer[$this->f]);// capture du bloc

   // $match
   if($type == "father")
     {
          //$this->_AddTraceMsg("bloc define as father $bloc_name");

          // definition du bloc pere direct
          $this->bloc[$this->f]["$bloc_name"]["structure"] = $struct_blc; // structure total du pre
          $this->bloc[$this->f]["$bloc_name"]["parsed"] = $struct_blc; // parsed
     }
   // enfant
   if($type == "children")
     {
      //$this->_AddTraceMsg("bloc define as children $bloc_name");

      $tmp_arr["structure"] = $struct_blc;
      $tmp_arr["parsed"] = $struct_blc;
     }

   $this->all_bloc_def[$this->f][] = $bloc_name;   // sauvegarde

   return $tmp_arr;   // retourne le bloc array
 }


// encapsulation d'un enfant
// le pere est considr comme dfini
 function _SaveChildrenBloc($bloc,$bloc_name,$fathers)
 {
    //$this->_AddTraceMsg("save children $bloc_name");


     $ref = &$this->bloc[$this->f];

     // prend le chemin et la structure des peres du bloc
     for($i=0;$i<count($fathers);$i++)
     {
       $ref = &$ref[$fathers[$i]]["children"];
     }

     // encapsulation chez son pere
     $ref["$bloc_name"] = $bloc;
 }

// criture des bloc avant une sortie !
 function _AllWriteBloc($id_bloc=-1,$level=0,$arr="",$bloc_name="")
 {
   //$this->_AddTraceMsg("write all bloc");

   if(empty($arr)) {$arr = &$this->bloc[$this->f];} // initialisation

   $keys = array_keys($arr); // les clefs ou blocs

   // pour chaque bloc y a til un fils
   for($i=0;$i<count($keys);$i++)
   {

   $cur_bloc_name = $keys[$i];
   $bloc_parsed = $arr[$cur_bloc_name]["parsed"];


     if($level == 0)
       {
        $id_bloc++;

        $this->end_bloc_tmp[$this->f][$id_bloc]["name"] = $cur_bloc_name;
        $this->end_bloc_tmp[$this->f][$id_bloc]["subject"] = $bloc_parsed;
       }
     else
      {
       $this->end_bloc_tmp[$this->f][$id_bloc][$level-1]["motif"][] = "/<bloc::$cur_bloc_name>(.*)?<\\/bloc::$cur_bloc_name>/msU";
       $this->end_bloc_tmp[$this->f][$id_bloc][$level-1]["replace"][] = $bloc_parsed;
      }

     //echo "$id_bloc $level $cur_bloc_name<br>\n";

     // les enfants du bloc
     if(count($arr[$cur_bloc_name]["children"]) > 0)
       {$this->_AllWriteBloc($id_bloc,$level+1,$arr[$cur_bloc_name]["children"],$cur_bloc_name);}
     }

 }


// fonction
 function _AllBlocParsingProcess()
 {
   //$this->_AddTraceMsg("write bloc in bloc");

   for($i=0;$i<count($this->end_bloc_tmp[$this->f]);$i++)
   {
     $cur_tmp = $this->end_bloc_tmp[$this->f][$i];
     $subject = $cur_tmp["subject"];
     $bloc_name = $cur_tmp["name"];

          for($j=0;$j<count($cur_tmp)-2;$j++)   // on retire le name & le subject
          {
              $motif = $cur_tmp[$j]["motif"];
              $replace = $cur_tmp[$j]["replace"];
              $subject = $this->_ReplaceBloc($motif,$replace,$subject);
          }

     // on remplace le bloc parsed dans le $this->bloc
     $this->f_buffer[$this->f] = $this->_ReplaceBloc($bloc_name,$subject,$this->f_buffer[$this->f]);
   }
}
















/***************** Plug in ***********************************/

/*****************************************************
                      logo
*****************************************************/
function _ParseLogo()
{
    if(@in_array("_Logo",$this->f_items[$this->f])) // on place le logo
    {
     //$this->_AddTraceMsg("parse logo");
     $this->Parse("_Logo","<a href=\"http://tpln.sourceforge.net\"><img src=\"http://tpln.sourceforge.net/logo.gif\" border=\"0\" width=\"83\" height=\"33\" alt=\"Visit HomePage\"></a>");
    }
}


/*****************************************************
                      chrono
*****************************************************/
// chrono ALL ou this ou ""
function SetChrono($type="this")
 {
  $this->chrono_type[$this->f] = $type;
 }

function _ParseChrono()
{
    if(@in_array("_Chrono",$this->f_items[$this->f])) // on place le chrono
    {
     //$this->_AddTraceMsg("parse chrono");
     $this->_GetExecutionTime();
     $this->Parse("_Chrono",$this->execution_time[$this->f]);
    }
}

// gestion du chrono
function _GetExecutionTime()
{
 $time = explode(' ',microtime());
 $fin = $time[1] + $time[0];

 // on veut les perf de cette session ou tous
 if($this->chrono_type[$this->f] == "ALL")
  {
   $this->execution_time[$this->f] = intval(10000 * ((double)$fin - (double)TPLN_CHRONO_STARTED)) / 10000;
   }
 else
  {
   $this->execution_time[$this->f] = intval(10000 * ((double)$fin - (double)$this->chrono_started[$this->f])) / 10000;
   }

 $this->execution_time[$this->f];
}

/*****************************************************
                      Cache
*****************************************************/

// retourne la valeur de la premire ligne
function _InCachePeriod()
{
  $expire = $this->_GetTime(TPLN_CACHE_DIR.$this->f_name[$this->f]);

  if($expire >= $this->time_started[$this->f])
   {
    return true;
   }
  else
   {
    @unlink(TPLN_CACHE_DIR.$this->f_name[$this->f]); // on efface le fichier
    return false;
   }
}

// prend le temps au dessus du fichier
function _GetTime()
{
 $fp = @fopen(TPLN_CACHE_DIR.$this->f_name[$this->f], "r");// ouvre le fichier
 $expire = trim(@fgets($fp,12));
 //$data = fread($fp, filesize($file));
 @fclose($fp);

 clearstatcache();

 return $expire;
}

function _CreateCache()
{
 if(!$this->add_cached_file[$this->f])
  {
   return;
  }
 else
  {
   $cache_file_content = $this->cache_expire[$this->f]."\r".$this->f_buffer[$this->f];
   //$this->_AddTraceMsg("create cached file");

   // ajout d'un fonction pour la cration de dossier
   $all_dir = explode("/",$this->f_name[$this->f]);
   if(count($all_dir) > 0)
    {
      $count = count($all_dir)-1; // on veut le dernier
      $act_dir = TPLN_CACHE_DIR;
      for($i=0;$i<$count;$i++)
       {
          $act_dir .= "/".$all_dir[$i];
          if(!is_dir($act_dir))
          {

            if(!@mkdir($act_dir,0755))
             {
              //$this->_AddTraceMsg("can't create dir $act_dir");
              //$this->_AddTraceMsg();
              $this->_Error(7);
              return;
             }

           //$this->_AddTraceMsg("create dir $act_dir ok");
           clearstatcache();
          }

       }
    }

   $fp = @fopen(TPLN_CACHE_DIR.$this->f_name[$this->f], "w"); // ouverture du fichier
   $this->f_buffer[$this->f] = @fwrite($fp,$cache_file_content);
   @fclose($fp);
   clearstatcache(); // efface la mmoire tampon
  }
}

function _GetCachedFile()
{
  $this->add_cached_file[$this->f] = 0;

  //$this->_AddTraceMsg("get cached file".TPLN_CACHE_DIR.$this->f_name[$this->f]);

  $fp = @fopen(TPLN_CACHE_DIR.$this->f_name[$this->f], "r");
  $tmp_expire = @fgets($fp,12); // pour la position du pointeur apres le temps
  $this->f_buffer[$this->f] = @fread($fp,filesize(TPLN_CACHE_DIR.$this->f_name[$this->f]));
  @fclose($fp);
  clearstatcache(); // efface la mmoire tampon
}

// verifie l'exitence du repertoire de cache et le crer ou cas ou
function _CacheDirExists()
{

 //$this->_AddTraceMsg("check cach directory ".TPLN_CACHE_DIR);

 // le repertoire existe ?
 if(!is_dir(TPLN_CACHE_DIR))
 {
   if(!@mkdir(TPLN_CACHE_DIR,0755))
    {
      //$this->_AddTraceMsg();
      $this->_Error(7);
      return;
    }

   clearstatcache();
 }
}


}

// fonction spciales
function _EvalBuffer($string)
{

 ob_start();
 eval(stripslashes("$string;"));
 $string = ob_get_contents();
 ob_end_clean();

 return $string;
}






?>